diff -bruN freeswan-1.9.orig/pluto/id.c freeswan-1.9/pluto/id.c
--- freeswan-1.9.orig/pluto/id.c	Wed Oct  4 20:12:10 2000
+++ freeswan-1.9/pluto/id.c	Wed Jun  6 16:40:59 2001
@@ -11,36 +11,45 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: id.c,v 1.11 2000/10/05 00:12:10 dhr Exp $
+ * RCSID $Id: id.c,v 1.15 2001/04/12 23:34:14 dhr Exp $
  */
 
 #include <stdlib.h>
 #include <string.h>
+#include <ctype.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 
+#ifdef OPENSSL
+#include <openssl/x509.h>	/* needed by DER handling */
+#endif
+
 #include <freeswan.h>
 
 #include "constants.h"
 #include "defs.h"
 #include "id.h"
+#include "log.h"
 #include "connections.h"	/* needs id.h */
 #include "packet.h"
 
 const struct id empty_id;	/* all zeros and NULLs */
 
-/* convert textual form of id into a (temporary) struct id */
-
+/* Convert textual form of id into a (temporary) struct id.
+ * Note that if the id is to be kept, unshare_id_content will be necessary.
+ */
 err_t
 atoid(char *src, struct id *id)
 {
     err_t ugh = NULL;
+#ifdef OPENSSL
+    char *nptr, *kptr;
+    char s[4];
+    u_int i;
+#endif
 
-    memset(id, 0, sizeof(*id));
-    id->name.ptr = NULL;
-    id->next = NULL;
-
+    *id = empty_id;
     if (strchr(src, '@') == NULL)
     {
 	/* !!! this test is not sufficient for distinguishing address families.
@@ -56,11 +65,70 @@
     {
 	if (*src == '@')
 	{
+#ifdef OPENSSL
+          /* if there is a second specifier (#) on the line
+           * we interprete this as ID_KEY_ID
+           */
+          if (*(src+1) == '#')
+          {
+            id->key_id.ptr = NULL;
+
+            id->kind = ID_KEY_ID;
+            id->name.ptr = src+2;
+            id->key_id.ptr = alloc_bytes(strlen(id->name.ptr)/2, "keyid-ptr");
+            id->key_id.len = strlen(id->name.ptr)/2;
+            nptr = id->name.ptr;
+            kptr = id->key_id.ptr;
+
+            for (i=0; i<  strlen(id->name.ptr)/2; i++, kptr++)
+            {
+              snprintf(s, 3, "%s", nptr);
+              *kptr = strtol(s, NULL, 16);
+              nptr+=2;
+            }
+            DBG(DBG_PARSING,
+            DBG_dump("Key-ID: ", id->key_id.ptr, id->key_id.len);
+            );
+          }
+          else if (*(src+1) == '~')
+          {
+            /* if there is a second specifier (~) on the line
+             * we interprete this as
+             *   ID_DER_ASN1_DN -> Distinguished Name
+             * in ASN1 (Subject-Field in X.509)
+             */
+            id->kind = ID_DER_ASN1_DN;
+            id->name.ptr = src+2;
+            id->der_asn1_dn.ptr = alloc_bytes(strlen(id->name.ptr)/2, "der_asn1_dn-ptr");
+            id->der_asn1_dn.len = strlen(id->name.ptr)/2;
+            nptr = id->name.ptr;
+            kptr = id->der_asn1_dn.ptr;
+
+            for (i=0; i<  strlen(id->name.ptr)/2; i++, kptr++)
+            {
+              snprintf(s, 3, "%s", nptr);
+              *kptr = strtol(s, NULL, 16);
+              nptr+=2;
+            }
+
+            DBG(DBG_PARSING,
+            DBG_dump("DER ASN1 DN: ", id->der_asn1_dn.ptr,
+              id->der_asn1_dn.len);
+            );
+
+            /* Check DN */
+            ugh = check_der_asn1_dn(id);
+
+          }
+          else
+          {
 	    id->kind = ID_FQDN;
 	    id->name.ptr = src+1;	/* discard @ */
 	}
+	}
 	else
 	{
+#endif /* OPENSSL */
 	    /* We leave in @, as per DOI 4.6.2.4
 	     * (but DNS wants . instead).
 	     */
@@ -72,39 +140,75 @@
     return ugh;
 }
 
+void
+iptoid(const ip_address *ip, struct id *id)
+{
+    *id = empty_id;
+
+    switch (addrtypeof(ip))
+    {
+    case AF_INET:
+	id->kind = ID_IPV4_ADDR;
+	break;
+    case AF_INET6:
+	id->kind = ID_IPV6_ADDR;
+	break;
+    default:
+	passert(FALSE);
+    }
+    id->ip_addr = *ip;
+}
+
 int
 idtoa(const struct id *id, char *dst, size_t dstlen)
 {
+    int n;
+
     switch (id->kind)
     {
     case ID_NONE:
-	return snprintf(dst, dstlen, "(none)");
+       n = snprintf(dst, dstlen, "(none)");
+       break;
     case ID_IPV4_ADDR:
     case ID_IPV6_ADDR:
-	return (int)addrtot(&id->ip_addr, 0, dst, dstlen) - 1;
+       n = (int)addrtot(&id->ip_addr, 0, dst, dstlen) - 1;
+       break;
     case ID_FQDN:
-	return snprintf(dst, dstlen, "@%.*s", (int)id->name.len, id->name.ptr);
+       n = snprintf(dst, dstlen, "@%.*s", (int)id->name.len, id->name.ptr);
+       break;
     case ID_USER_FQDN:
-	return snprintf(dst, dstlen, "%.*s", (int)id->name.len, id->name.ptr);
+       n = snprintf(dst, dstlen, "@%.*s", (int)id->name.len, id->name.ptr);
+       break;
+#ifdef OPENSSL
+    case ID_KEY_ID:
+       n = snprintf(dst, dstlen, "@%.*s", (int)id->key_id.len, id->key_id.ptr);
+       break;
+    case ID_DER_ASN1_DN:
+       n = snprintf(dst, dstlen, "@%.*s", (int)id->der_asn1_dn.len,
+       id->der_asn1_dn.ptr);
+       break;
+#endif
     default:
-	return snprintf(dst, dstlen, "unknown id kind %d", id->kind);
+        n = snprintf(dst, dstlen, "unknown id kind %d", id->kind);
+	break;
     }
-}
 
-/* deep-copy a struct id into a new heap object
- * This is needed if the result of atoid is to be kept.
+    /* "Sanitize" string so that log isn't endangered:
+     * replace unprintable characters with '?'.
  */
+    if (n > 0)
+    {
+       for ( ; *dst != '\0'; dst++)
+           if (!isprint(*dst))
+               *dst = '?';
+    }
 
-struct id *
-clone_id(const struct id *src)
-{
-    struct id *dst = clone_thing(*src, "keep id");
-
-    unshare_id_content(dst);
-    dst->next = NULL;
-    return dst;
+    return n;
 }
 
+/* Make private copy of string in struct id.
+ * This is needed if the result of atoid is to be kept.
+ */
 void
 unshare_id_content(struct id *id)
 {
@@ -112,8 +216,20 @@
     {
     case ID_FQDN:
     case ID_USER_FQDN:
-	id->name.ptr = clone_bytes(id->name.ptr, id->name.len, "keep id name");
+#ifdef OPENSSL
+    case ID_KEY_ID:
+#endif
+	id->name.ptr = clone_bytes(id->name.ptr, id->name.len, 
+		"keep id name");
+	break;
+#ifdef OPENSSL
+    case ID_DER_ASN1_DN:
+	id->name.ptr = clone_bytes(id->name.ptr, id->name.len, 
+		"keep id name");
+	id->der_asn1_dn.ptr = clone_bytes(id->der_asn1_dn.ptr, 
+		id->der_asn1_dn.len, "keep der_asn1_dn id");
 	break;
+#endif
     case ID_NONE:
     case ID_IPV4_ADDR:
     case ID_IPV6_ADDR:
@@ -140,6 +256,16 @@
     case ID_USER_FQDN:
 	pfree(id->name.ptr);
 	break;
+#ifdef OPENSSL
+    case ID_KEY_ID:
+	pfree(id->name.ptr);
+	pfree(id->key_id.ptr);
+	break;
+    case ID_DER_ASN1_DN:
+	pfree(id->name.ptr);
+	pfree(id->der_asn1_dn.ptr);
+	break;
+#endif /* OPENSSL */
     case ID_NONE:
     case ID_IPV4_ADDR:
     case ID_IPV6_ADDR:
@@ -166,10 +292,20 @@
 
     case ID_FQDN:
     case ID_USER_FQDN:
+#ifdef OPENSSL
+    case ID_KEY_ID:
 	/* assumption: case should be ignored */
+#endif
 	return a->name.len == b->name.len
 	    && strncasecmp(a->name.ptr, b->name.ptr, a->name.len) == 0;
+#ifdef OPENSSL
+    case ID_DER_ASN1_DN:
+	/* assumption: case should be ignored */
 
+	return (a->der_asn1_dn.len == b->der_asn1_dn.len)
+	    && strncasecmp(a->der_asn1_dn.ptr, 
+	      b->der_asn1_dn.ptr, a->der_asn1_dn.len) == 0;
+#endif /* OPENSSL */
     default:
 	passert(FALSE);
     }
@@ -183,7 +319,7 @@
 void
 build_id_payload(struct isakmp_ipsec_id *hd, chunk_t *tl, struct end *end)
 {
-    memset(hd, '\0', sizeof(*hd));
+    zero(hd);
     hd->isaiid_idtype = end->id.kind;
     switch (end->id.kind)
     {
@@ -201,7 +337,49 @@
 	tl->len = addrbytesptr(&end->host_addr
 	    , (const unsigned char **)&tl->ptr);
 	break;
+#ifdef OPENSSL
+    case ID_KEY_ID:
+	*tl = end->id.key_id;
+	break;
+    case ID_DER_ASN1_DN:
+	*tl = end->id.der_asn1_dn;
+	break;
+#endif /* OPENSSL */
     default:
 	passert(FALSE);
     }
 }
+
+#ifdef OPENSSL
+err_t
+check_der_asn1_dn(struct id *id)
+{
+	err_t ugh = NULL;
+	u_char *temp_ptr;
+
+	X509_NAME *xn = X509_NAME_new();
+	char dnout[256];
+
+	if (xn == NULL) {
+		ugh="Unable to malloc X509_NAME *xn";
+	}
+
+	/* temp_ptr because d2i_X509_NAME will mangle the pointer. */
+	temp_ptr = id->der_asn1_dn.ptr;
+	xn = d2i_X509_NAME(&xn, &(id->der_asn1_dn.ptr),
+		(long)id->der_asn1_dn.len);
+	id->der_asn1_dn.ptr = temp_ptr;
+
+	if (xn != NULL) {
+		DBG(DBG_PARSING,
+		X509_NAME_oneline(xn,dnout,256);
+		DBG_log("Valid DN == %s", dnout);
+		);
+	} else {
+		ugh="Invalid DER string";
+	}
+
+	X509_NAME_free(xn);
+	return ugh;
+}
+#endif
diff -bruN freeswan-1.9.orig/pluto/id.h freeswan-1.9/pluto/id.h
--- freeswan-1.9.orig/pluto/id.h	Wed Oct  4 20:12:10 2000
+++ freeswan-1.9/pluto/id.h	Tue Jun  5 15:56:51 2001
@@ -11,28 +11,35 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: id.h,v 1.11 2000/10/05 00:12:10 dhr Exp $
+ * RCSID $Id: id.h,v 1.15 2001/02/26 23:50:11 dhr Exp $
  */
 
 struct id {
     int kind;	/* ID_* value */
     ip_address ip_addr;	/* ID_IPV4_ADDR, ID_IPV6_ADDR */
+#ifdef OPENSSL
+    chunk_t key_id;   /* ID_KEY_ID */
+    chunk_t der_asn1_dn;      /* ID_DER_ASN1_DN */
+#endif
     chunk_t name;	/* ID_FQDN, ID_USER_FQDN (with @) */
-    struct id *next;
 };
 
 extern const struct id empty_id;
 
 extern err_t atoid(char *src, struct id *id);
+extern void iptoid(const ip_address *ip, struct id *id);
 extern int idtoa(const struct id *id, char *dst, size_t dstlen);
 #define IDTOA_BUF 256
 struct end;	/* forward declaration of tag (defined in connections.h) */
-extern struct id *clone_id(const struct id *src);
 extern void unshare_id_content(struct id *id);
 extern void free_id(struct id *id);
 extern void free_id_content(struct id *id);
 extern bool same_id(const struct id *a, const struct id *b);
+#define id_is_ipaddr(id) ((id)->kind == ID_IPV4_ADDR || (id)->kind == ID_IPV6_ADDR)
 
 struct isakmp_ipsec_id;	/* forward declaration of tag (defined in packet.h) */
 extern void
     build_id_payload(struct isakmp_ipsec_id *hd, chunk_t *tl, struct end *end);
+#ifdef OPENSSL
+err_t check_der_asn1_dn(struct id *id);
+#endif
